// WriteStr v2.01 - C
// WriteStr(STRING,X,Y[,COL][,FONT][,SCREEN])

#define _92plus      // define _92plus or _89
//#define _89

#include <nostub.h>  // Make NoStub Program
#include <all.h>     // Include All Header Files

#define graph_screen 0
#define prgmio_screen 1

#if defined(_92plus)
 #if defined(_89)
 #error Both _89 and _92plus are defined
 #endif
 int _ti92plus;       // Produce .9XZ File
 #define OFFSet 18
 #define Xmax 239
 #define Ymax 102
 #define len 30
 #define OFFSet2 0x21c
#elif defined(_89)
 int _ti89;           // Produce .89Z File
 #define OFFSet 16
 #define Xmax 159
 #define Ymax 76
 #define len 20
 #define OFFSet2 0x1e0
#else
#error Target product not defined
#endif

char _comment[] = "STRING,X,Y[,MODE][,FONT][,SCREEN]";

#define check(condition,err_no) \
	{ if(condition) { ERD_dialog(err_no,FALSE); ST_helpMsg(_comment); return 1; } }
	
// Main Function
int _main()
{
	//Variable Declaration
	ESI ArgPtr;
	char* str;
	int x,y,oldfnt,fnt,i;
	int screen=graph_screen;
	int mode=A_NORMAL;
	void* memloc1;
	void* memloc2;

	//Initialize argument checking
	InitArgPtr(ArgPtr);

	//Error checking on passed arguments, and variable assignment
	i = ArgCount();
	check( i < 3, 930 );
	check( i > 6, 940 );

	check( GetArgType(ArgPtr)!=STR_TAG, 130 );
	str = GetStrnArg(ArgPtr);
 
	check( GetArgType(ArgPtr)!=POSINT_TAG, 210 );
	x = GetIntArg(ArgPtr);
	check( x > Xmax, 260 );

	check( GetArgType(ArgPtr)!=POSINT_TAG, 210 );
	y = GetIntArg(ArgPtr);
	check( y > Ymax, 260 );
	y+=OFFSet;

	if ( i > 3 )
	{
		check( GetArgType(ArgPtr)!=POSINT_TAG, 210 );
		mode = GetIntArg(ArgPtr);
		check( mode > 4,  260);
	}

	if ( i > 4 )
	{
		check( GetArgType(ArgPtr)!=POSINT_TAG, 210 );
		fnt = GetIntArg(ArgPtr);
		check( fnt > 2, 260 );
	}
	
	if ( i > 5 )
	{
		check( GetArgType(ArgPtr)!=POSINT_TAG, 210 );
		screen = GetIntArg(ArgPtr);
		check( screen > 1, 260 );
	}
  
	//Display the Graph/PrgmIO Screen
	if ( screen == graph_screen )
		cmd_dispg();
	else
		cmd_disp( ArgPtr );

	//Display Text
	oldfnt = FontGetSys();
	if ( i > 4 )
		FontSetSys(fnt);
	DrawStr(x,y,str,mode);
	FontSetSys(oldfnt);
	
	//Fix bottom of screen just in case it got messed up
	DrawLine(0,Ymax+OFFSet+1,Xmax,Ymax+OFFSet+1,A_NORMAL);
	ST_helpMsg("");
	ST_eraseHelp();

	//Copy to the graph screen
	memloc1 = HeapDeref(FirstWindow->DupScr)+4;
	memloc2 = LCD_MEM+OFFSet2;
	for ( i = 0; i <= Ymax; i++ )
	{
		memcpy(memloc1, memloc2, len);
		memloc1 += len;
		memloc2 += 30;
	}
	//Exit
	return 0;
}
